unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, DB, ADODB, Grids, DBGrids, StdCtrls, QuickRpt, QRCtrls, ExtCtrls,
  ppCtrls, ppVar, ppPrnabl, ppClass, ppDB, ppBands, ppCache, ppDBPipe,
  ppComm, ppRelatv, ppProd, ppReport, DBClient, Buttons, ppDBBDE;

type
  TForm1 = class(TForm)
    Query1: TADOQuery;
    DataSource1: TDataSource;
    DBGrid1: TDBGrid;
    Query1date: TDateTimeField;
    Query1doc_no: TStringField;
    Query1match_doc: TStringField;
    Query1descrip: TStringField;
    Query1type: TStringField;
    Query1amount: TFloatField;
    Query1debit: TFloatField;
    Query1credit: TFloatField;
    Query1balance: TFloatField;
    Button2: TButton;
    QuickRep1: TQuickRep;
    QRBand1: TQRBand;
    QRLabel1: TQRLabel;
    QRBand2: TQRBand;
    QRBand3: TQRBand;
    QRBand4: TQRBand;
    QRDBText1: TQRDBText;
    QRDBText2: TQRDBText;
    QRDBText3: TQRDBText;
    QRDBText4: TQRDBText;
    QRDBText5: TQRDBText;
    QRDBText6: TQRDBText;
    QRDBText7: TQRDBText;
    QRDBText8: TQRDBText;
    QRLabel2: TQRLabel;
    QRLabel3: TQRLabel;
    QRLabel4: TQRLabel;
    QRLabel5: TQRLabel;
    QRLabel6: TQRLabel;
    QRLabel7: TQRLabel;
    QRLabel8: TQRLabel;
    QRLabel9: TQRLabel;
    QRShape1: TQRShape;
    Button3: TButton;
    ppReport1: TppReport;
    ppHeaderBand1: TppHeaderBand;
    ppDetailBand1: TppDetailBand;
    ppFooterBand1: TppFooterBand;
    ppLabel1: TppLabel;
    ppDBText1: TppDBText;
    ppLabel2: TppLabel;
    ppLabel3: TppLabel;
    ppDBText2: TppDBText;
    ppLabel4: TppLabel;
    ppLabel5: TppLabel;
    ppLabel6: TppLabel;
    ppLabel7: TppLabel;
    ppLabel8: TppLabel;
    ppLabel9: TppLabel;
    ppDBText4: TppDBText;
    ppDBText5: TppDBText;
    ppDBText6: TppDBText;
    ppLine1: TppLine;
    cds: TClientDataSet;
    BitBtn1: TBitBtn;
    sqlHpStt: TADOQuery;
    ppDBText3: TppDBText;
    ppDBText7: TppDBText;
    ppDBText8: TppDBText;
    ppBDEPipeline1: TppBDEPipeline;
    procedure Query1CalcFields(DataSet: TDataSet);
    procedure Button2Click(Sender: TObject);
    procedure QuickRep1BeforePrint(Sender: TCustomQuickRep;
      var PrintReport: Boolean);
    procedure Button3Click(Sender: TObject);
    procedure BitBtn1Click(Sender: TObject);
  private
    { Private declarations }
  public
    procedure OpenDataSet;
    { Public declarations }
  end;

var
  Form1: TForm1;
  balance: Real;

implementation

{$R *.dfm}

procedure TForm1.Query1CalcFields(DataSet: TDataSet);
Var
 amount:real;
begin
 amount:=Query1.FieldByName('AMOUNT').AsFloat;
 if Query1amount.Value>0 then begin
  Query1debit.Value:=amount;
  balance:=balance+amount;
 end
 else begin
  Query1credit.Value:=abs(amount);
  balance:=balance-abs(amount);
 end;
 Query1balance.Value:=balance;


end;

procedure TForm1.Button2Click(Sender: TObject);
begin
 OpenDataSet;
 quickrep1.Preview;
end;

procedure TForm1.QuickRep1BeforePrint(Sender: TCustomQuickRep;
  var PrintReport: Boolean);
begin
 balance:=0;
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
 OpenDataSet;
 ppReport1.print;
end;

procedure TForm1.BitBtn1Click(Sender: TObject);
begin
OpenDataSet;
end;


procedure TForm1.OpenDataSet;
Var
  i : Integer ;
  fn : String ;
  amount,balance: Real;
begin
  balance:=0;
  sqlHpStt.Open;
  With cds Do Begin
    Close;
    FieldDefs := sqlHpStt.FieldDefs ;
    FieldDefs.Add('Debit'  ,ftFloat,0,False);
    FieldDefs.Add('Credit' ,ftFloat,0,False);
    FieldDefs.Add('Balance',ftFloat,0,False);
    CreateDataSet;
    While Not sqlHpStt.Eof Do Begin
      Append;
      For i:=0 To sqlHpStt.FieldCount-1 Do Begin
        fn := sqlHpStt.Fields[i].FieldName ;
        If FindField(fn) <> nil Then
          FieldByName(fn).Value := sqlHpStt.Fields[i].Value; 
      End;
      amount:=sqlHpStt.FieldByName('Amount').Value;
      balance:=balance+ amount;
      if amount > 0 then
        FieldByname('Debit').AsFloat := amount
      else if amount < 0 then
         FieldByname('Credit').AsFloat:= abs(amount);

      FieldByname('Balance').AsFloat :=balance;
      Post;
      sqlHpStt.Next;
    End;
  End;
  sqlHpStt.Close;

  for i:=0 to cds.FieldCount-1 do begin
   cds.Fields[i].DisplayWidth:=12;
  end;

end;



end.
